import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Plane here.
 * Thanks to Kenny for the assests!
 * @author Jed Wilshire 
 * @version 1.0
 */
public class Plane extends Actor
{
    public static final double GRAVITY = 0.3;
    public static final double TAP_POWER = -6.5;
    
    private GreenfootImage img1;
    private GreenfootImage img2;
    private GreenfootImage img3;
    private boolean alive;
    private double dy;
    private GreenfootSound engineSound;
    private GreenfootSound explosion;
    public Plane() {
        img1 = new GreenfootImage("plane1.png");
        img2 = new GreenfootImage("plane2.png");
        img3 = new GreenfootImage("plane3.png");
        setImage(img1);
        alive = true;
        dy = 0;
        engineSound = new GreenfootSound("engineSound.wav");
        explosion = new GreenfootSound("explosion.wav");
    }
    
    /**
     * Act - do whatever the Plane wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() {
        if (!engineSound.isPlaying() && alive) {
            engineSound.playLoop();
        }
        if (getY() < 0 || getY() > getWorld().getHeight() || getOneIntersectingObject(RockHitBox.class) != null) {
            if (alive) {
                explosion.play();
            }
            alive = false;
            setImage(new GreenfootImage("plane_dead.png"));
            engineSound.stop();          
        }
        if (alive) {
            switchCostume();
        }
        dy += GRAVITY;
        if (alive && Greenfoot.isKeyDown("space")) {
            dy = TAP_POWER;
        }
        setLocation(getX(), (int) (getY() + dy));
    }  
    
    public boolean isAlive() {
        return alive;
    }
    
    public void switchCostume() {
        if (getImage().equals(img1)) {
            setImage(img2);
        } else if (getImage().equals(img2)) {
            setImage(img3);
        } else {
            setImage(img1);
        }
    }
}
